import pygame
from Mind import *

from doc.src import main, consts, tools


class Game:
    def __init__(self):
        self.screen = consts.SCREEN

        self.places = [Imagination.PLACE() for x in range(4)]

        self.game = Imagination.Game(self.places[0])

        self.keyboard = consts.KEYBOARD
        self.game.declare(Imagination.Vertical_menu, distance=200,
                          keyboard=consts.KEYBOARD)

        self.game.define(type_=Imagination.text_option, font=consts.FONTS[0],
                         color=consts.BLACK,
                         pos_do=Imagination.ch_color(consts.RED),
                         anti_pos_do=Imagination.reset())

        self.event_dealer = tools.EventDealer()

        self.scene = tools.Scene(self.game, self.places)

        self.main_menu = self.game.set_from(places=self.places[0])

        self.main_menu.set_from(type=Imagination.fake_txt_opt, text="Rejected Survivor")
        self.main_menu.set_from(True, text="Start",
                                do=Imagination.link(self.places[3]))
        self.main_menu.set_from(text="Quit", do=Imagination.Quit)

        self.main_menu.set_options()

        self.quit_menu = self.game.set_from(places=self.places[2])

        self.quit_menu.set_from(type=Imagination.fake_txt_opt, text="You died!")
        self.quit_menu.set_from(True, text="Try again")
        self.quit_menu.set_from(text="Main Menu",
                                do=Imagination.link(self.places[0]))
        self.quit_menu.set_from(text="Quit", do=Imagination.Quit)

        self.quit_menu.set_options()

        self.dark = tools.Dark(self.screen, consts.LIGHT_SIZE,
                               consts.DARK_PERCENT)

        self.level = main.Level("1", self)

        self.clock = pygame.time.Clock()

        pygame.mouse.set_visible(False)

    def run(self):
        while self.game.run():
            if self.places[0] and self.keyboard["quit"] == 1:
                self.game.kill()

            self.screen.fill(consts.NIGHT)

            self.game.blit()

            if self.places[1]:
                self.level.blit()
            else:
                self.dark.blit(False)

            self.event_dealer.clear()

            pygame.display.flip()

            self.clock.tick(consts.MAX_FPS)

game = Game()
game.run()

pygame.quit()
